#include <SoftwareSerial.h> // Software Serial Bibliothek einbinden

/////////////////////////////////////////////////////////////// Pins deklarieren

const int BTRX=2; // Arduino Recieve <- BT Send
const int BTTX=3; // Arduino Send -> BT Receive

const int tastervor=12;
const int tasterstopp=11;
const int tasterzurueck=10;
const int tasterlicht=9;

const int tastergang1=14;
const int tastergang2=15;
const int tastergang3=16;
const int tastergang4=17;
const int tastergang5=18;
const int tastergang6=19;

const int ledvor=5;
const int ledstopp=6;
const int ledzurueck=7;
const int ledlicht=4;

int bereit=0;

/////////////////////////////////////////////////////////////// Variablen deklarieren

SoftwareSerial SerialBT(BTRX, BTTX); //Softwareserial konfigurieren

int msg; //Wert des Empfangenen BT Befehls

int gangcode=0; //Wert zur Übertragung des aktuellen Ganges an die Lok

int letztergangcode=0;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////// Setup //////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void setup() {
SerialBT.begin(9600); // Startet die Datenübertragung mit 9600 Baud an die Lok

Serial.begin(9600); // Startet die Bluetoothdatenübertragung mit 9600 Baud an den PC
Serial.println("Verbindung steht"); //OK an den PC

//Taster Eingänge
  pinMode(tastervor, INPUT); 
  pinMode(tasterstopp, INPUT);
  pinMode(tasterzurueck, INPUT);

//Ausgänge 
  pinMode(ledvor, OUTPUT); 
  pinMode(ledstopp, OUTPUT);
  pinMode(ledzurueck, OUTPUT);
  pinMode(ledlicht, OUTPUT);  

//Eingänge für Gang
  pinMode(tastergang1, INPUT);
  pinMode(tastergang2, INPUT);
  pinMode(tastergang3, INPUT);
  pinMode(tastergang4, INPUT);
  pinMode(tastergang5, INPUT);
  pinMode(tastergang6, INPUT);

//den am Anfang eingestellten Gang ind die Variable gangcode übertragen

if (digitalRead(tastergang6)==HIGH) gangcode=11;
if (digitalRead(tastergang6)==HIGH) gangcode=12;
if (digitalRead(tastergang6)==HIGH) gangcode=13;
if (digitalRead(tastergang6)==HIGH) gangcode=14;
if (digitalRead(tastergang6)==HIGH) gangcode=15;
if (digitalRead(tastergang6)==HIGH) gangcode=16;

letztergangcode=gangcode;

//initiales Blinken der Buttons
  digitalWrite(ledvor, HIGH);
  digitalWrite(ledstopp, HIGH);
  digitalWrite(ledzurueck, HIGH);
  digitalWrite(ledlicht, HIGH);  

delay(200);

  digitalWrite(ledvor, LOW);
  digitalWrite(ledstopp, LOW);
  digitalWrite(ledzurueck, LOW);
  digitalWrite(ledlicht, LOW); 

delay(200);

  digitalWrite(ledvor, HIGH);
  digitalWrite(ledstopp, HIGH);
  digitalWrite(ledzurueck, HIGH);
  digitalWrite(ledlicht, HIGH);  

delay(200);

  digitalWrite(ledvor, LOW);
  digitalWrite(ledstopp, LOW);
  digitalWrite(ledzurueck, LOW);
  digitalWrite(ledlicht, LOW); 

Serial.println("Bereit"); // Ausgabe auf der seriellen Schnittstelle

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////// LOOP ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void loop() {


//den aktuellen Gang in die Variable gangcode übertragen

if (digitalRead(tastergang1)==HIGH)
{
  gangcode=11;
}

if (digitalRead(tastergang2)==HIGH)
{
  gangcode=12;
}

if (digitalRead(tastergang3)==HIGH)
{
  gangcode=13;
}

if (digitalRead(tastergang4)==HIGH)
{
  gangcode=14;
}
if (digitalRead(tastergang5)==HIGH)
{
  gangcode=15;
}

if (digitalRead(tastergang6)==HIGH)
{
  gangcode=16;
}

if(gangcode!=letztergangcode)
{
Serial.print("Sende Gangcode "); // Ausgabe des aktuellen Ganges auf den PC
Serial.print(gangcode); // Ausgabe des aktuellen Ganges auf den PC
Serial.println(" an Lok"); // Ausgabe des aktuellen Ganges auf den PC
SerialBT.write(gangcode); // gangcode an die Lok senden  
delay(50);
letztergangcode=gangcode; //aktuellen Gangcode übernehmen
delay(50);
}



if (digitalRead(tastervor) == HIGH) //Wenn Taster vor gedrückt
{
Serial.println("Taster vor gedrueckt"); // Ausgabe auf der seriellen Schnittstelle
digitalWrite(ledvor, HIGH); //LED vor aktivieren
digitalWrite(ledstopp, LOW); // andere LED deaktivieren
digitalWrite(ledzurueck, LOW);
SerialBT.write(1); //Code für vorwärts an die Lok senden
delay (100); // kurz warten
}


if (digitalRead(tasterstopp) == HIGH) //Taster stopp ausgelesen
{
  Serial.println("Taster stopp gedrueckt"); // Ausgabe auf der seriellen Schnittstelle
digitalWrite(ledvor, LOW);
digitalWrite(ledstopp, HIGH);
digitalWrite(ledzurueck, LOW);
SerialBT.write(2); //Code für stopp an die Lok senden
delay (100);
}


if (digitalRead(tasterzurueck) == HIGH)  //Taster Zurueck ausgelesen
{
  Serial.println("Taster zurueck gedrueckt"); // Ausgabe auf der seriellen Schnittstelle
digitalWrite(ledvor, LOW);
digitalWrite(ledstopp, LOW);
digitalWrite(ledzurueck, HIGH);
SerialBT.write(3);//Code für zurück an die Lok senden
delay (100);
}


if (digitalRead(tasterlicht) == HIGH) //wenn Taster Licht gedrückt
{
  SerialBT.write(4); //Code für Licht an die Lok senden
  Serial.println("Taster Licht gedrueckt"); // Ausgabe auf der seriellen Schnittstelle
  delay(500);
}

if (SerialBT.available() > 0) // wenn sinnvolle BT Daten empfangen werden
{      
     msg = SerialBT.read(); // Nachricht lesen
     Serial.println(msg);

switch(msg) // Abhaengig vom Signal in den richtigen Modus springen
{
 
 case 20: // wenn Licht an Empfangen
      Serial.println("Licht an Empfangen"); // Ausgabe auf der Seriellen schnittstelle
      digitalWrite(ledlicht, HIGH); // ...dann anschalten   
 break;

  case 21: // wenn Licht aus Empfangen
      Serial.println("Licht aus Empfangen"); // Ausgabe auf der Seriellen schnittstelle
      digitalWrite(ledlicht, LOW); // ...dann anschalten   
 break;

   case 99: // wenn OK Empfangen
      Serial.println("OK Empfangen"); // Ausgabe auf der Seriellen schnittstelle
      SerialBT.write(99); // Bereitschaft bestätigen
      delay(100);
      SerialBT.write(gangcode); //sende gangcode an Lok
      delay(100);
 break;
}
}
  

}
